Index: src/includes/classes/Smarty/sysplugins/smarty_template_compiled.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_template_compiled.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_template_compiled.php	(revision )
@@ -0,0 +1,297 @@
+<?php
+
+/**
+ * Smarty Resource Data Object
+ * Meta Data Container for Template Files
+ *
+ * @package    Smarty
+ * @subpackage TemplateResources
+ * @author     Rodney Rehm
+ * @property string $content compiled content
+ */
+class Smarty_Template_Compiled extends Smarty_Template_Resource_Base
+{
+
+    /**
+     * nocache hash
+     *
+     * @var string|null
+     */
+    public $nocache_hash = null;
+
+    /**
+     * get a Compiled Object of this source
+     *
+     * @param  Smarty_Internal_Template $_template template object
+     *
+     * @return Smarty_Template_Compiled compiled object
+     */
+    static function load($_template)
+    {
+        // check runtime cache
+        if (!$_template->source->handler->recompiled &&
+            ($_template->smarty->resource_cache_mode & Smarty::RESOURCE_CACHE_ON)
+        ) {
+            $_cache_key = $_template->source->unique_resource . '#';
+            if ($_template->caching) {
+                $_cache_key .= 'caching#';
+            }
+            $_cache_key .= $_template->compile_id;
+            if (isset($_template->source->compileds[$_cache_key])) {
+                return $_template->source->compileds[$_cache_key];
+            }
+        }
+        $compiled = new Smarty_Template_Compiled();
+        if ($_template->source->handler->hasCompiledHandler) {
+            $_template->source->handler->populateCompiledFilepath($compiled, $_template);
+        } else {
+            $compiled->populateCompiledFilepath($_template);
+        }
+        // runtime cache
+        if (!$_template->source->handler->recompiled &&
+            ($_template->smarty->resource_cache_mode & Smarty::RESOURCE_CACHE_ON)
+        ) {
+            $_template->source->compileds[$_cache_key] = $compiled;
+        }
+        return $compiled;
+    }
+
+    /**
+     * populate Compiled Object with compiled filepath
+     *
+     * @param Smarty_Internal_Template $_template template object
+     **/
+    public function populateCompiledFilepath(Smarty_Internal_Template $_template)
+    {
+        $_compile_id = isset($_template->compile_id) ? preg_replace('![^\w]+!', '_', $_template->compile_id) : null;
+        if ($_template->source->isConfig) {
+            $_flag = '_' .
+                ((int) $_template->smarty->config_read_hidden + (int) $_template->smarty->config_booleanize * 2 +
+                    (int) $_template->smarty->config_overwrite * 4);
+        } else {
+            $_flag =
+                '_' . ((int) $_template->smarty->merge_compiled_includes + (int) $_template->smarty->escape_html * 2);
+        }
+        $_filepath = $_template->source->uid . $_flag;
+        // if use_sub_dirs, break file into directories
+        if ($_template->smarty->use_sub_dirs) {
+            $_filepath = substr($_filepath, 0, 2) . DS . substr($_filepath, 2, 2) . DS . substr($_filepath, 4, 2) . DS .
+                $_filepath;
+        }
+        $_compile_dir_sep = $_template->smarty->use_sub_dirs ? DS : '^';
+        if (isset($_compile_id)) {
+            $_filepath = $_compile_id . $_compile_dir_sep . $_filepath;
+        }
+        // caching token
+        if ($_template->caching) {
+            $_cache = '.cache';
+        } else {
+            $_cache = '';
+        }
+        $_compile_dir = $_template->smarty->getCompileDir();
+        // set basename if not specified
+        $_basename = $_template->source->handler->getBasename($_template->source);
+        if ($_basename === null) {
+            $_basename = basename(preg_replace('![^\w]+!', '_', $_template->source->name));
+        }
+        // separate (optional) basename by dot
+        if ($_basename) {
+            $_basename = '.' . $_basename;
+        }
+
+        $this->filepath = $_compile_dir . $_filepath . '.' . $_template->source->type . $_basename . $_cache . '.php';
+        $this->exists = is_file($this->filepath);
+        if (!$this->exists) {
+            $this->timestamp = false;
+        }
+    }
+
+    /**
+     * load compiled template or compile from source
+     *
+     * @param Smarty_Internal_Template $_template
+     *
+     * @throws Exception
+     */
+    public function process(Smarty_Internal_Template $_template)
+    {
+        $_smarty_tpl = $_template;
+        if ($_template->source->handler->recompiled || !$_template->compiled->exists ||
+            $_template->smarty->force_compile || ($_template->smarty->compile_check &&
+                $_template->source->getTimeStamp() > $_template->compiled->getTimeStamp())
+        ) {
+            $this->compileTemplateSource($_template);
+            $compileCheck = $_template->smarty->compile_check;
+            $_template->smarty->compile_check = false;
+            if ($_template->source->handler->recompiled) {
+                $level = ob_get_level();
+                ob_start();
+                try {
+                    eval("?>" . $this->content);
+                }
+                catch (Exception $e) {
+                    while (ob_get_level() > $level) {
+                        ob_end_clean();
+                    }
+                    throw $e;
+                }
+                ob_get_clean();
+                $this->content = null;
+            } else {
+                $this->loadCompiledTemplate($_template);
+            }
+            $_template->smarty->compile_check = $compileCheck;
+        } else {
+            $_template->mustCompile = true;
+            @include($_template->compiled->filepath);
+            if ($_template->mustCompile) {
+                $this->compileTemplateSource($_template);
+                $compileCheck = $_template->smarty->compile_check;
+                $_template->smarty->compile_check = false;
+                $this->loadCompiledTemplate($_template);
+                $_template->smarty->compile_check = $compileCheck;
+            }
+        }
+        $_template->smarty->ext->_subTemplate->registerSubTemplates($_template);
+
+        $this->processed = true;
+    }
+
+    /**
+     * Load fresh compiled template by including the PHP file
+     * HHVM requires a work around because of a PHP incompatibility
+     *
+     * @param \Smarty_Internal_Template $_template
+     */
+    private function loadCompiledTemplate(Smarty_Internal_Template $_template)
+    {
+        if (function_exists('opcache_invalidate')) {
+            opcache_invalidate($_template->compiled->filepath);
+        }
+        $_smarty_tpl = $_template;
+        if (defined('HHVM_VERSION')) {
+            $_template->smarty->ext->_hhvm->includeHhvm($_template, $_template->compiled->filepath);
+        } else {
+            include($_template->compiled->filepath);
+        }
+    }
+
+    /**
+     * render compiled template code
+     *
+     * @param Smarty_Internal_Template $_template
+     *
+     * @return string
+     * @throws Exception
+     */
+    public function render(Smarty_Internal_Template $_template)
+    {
+        if ($_template->smarty->debugging) {
+            $_template->smarty->_debug->start_render($_template);
+        }
+        if (!$this->processed) {
+            $this->process($_template);
+        }
+        if (isset($_template->cached)) {
+            $_template->cached->file_dependency =
+                array_merge($_template->cached->file_dependency, $this->file_dependency);
+        }
+        $this->getRenderedTemplateCode($_template);
+        if ($_template->caching && $this->has_nocache_code) {
+            $_template->cached->hashes[$this->nocache_hash] = true;
+        }
+        if (isset($_template->parent) && $_template->parent->_objType == 2 && !empty($_template->tpl_function)) {
+            $_template->parent->tpl_function = array_merge($_template->parent->tpl_function, $_template->tpl_function);
+        }
+        if ($_template->smarty->debugging) {
+            $_template->smarty->_debug->end_render($_template);
+        }
+    }
+
+    /**
+     * compile template from source
+     *
+     * @param Smarty_Internal_Template $_template
+     *
+     * @return string
+     * @throws Exception
+     */
+    public function compileTemplateSource(Smarty_Internal_Template $_template)
+    {
+        $_template->source->compileds = array();
+        $this->file_dependency = array();
+        $this->tpl_function = array();
+        $this->includes = array();
+        $this->nocache_hash = null;
+        $this->unifunc = null;
+        // compile locking
+        if (!$_template->source->handler->recompiled) {
+            if ($saved_timestamp = $_template->compiled->getTimeStamp()) {
+                touch($_template->compiled->filepath);
+            }
+        }
+        // call compiler
+        try {
+            $_template->loadCompiler();
+            $code = $_template->compiler->compileTemplate($_template);
+        }
+        catch (Exception $e) {
+            // restore old timestamp in case of error
+            if (!$_template->source->handler->recompiled && $saved_timestamp) {
+                touch($_template->compiled->filepath, $saved_timestamp);
+            }
+            throw $e;
+        }
+        // compiling succeeded
+        if ($_template->compiler->write_compiled_code) {
+            // write compiled template
+            $this->write($_template, $code);
+            $code = '';
+        }
+        // release compiler object to free memory
+        unset($_template->compiler);
+        return $code;
+    }
+
+    /**
+     * Write compiled code by handler
+     *
+     * @param Smarty_Internal_Template $_template template object
+     * @param string                   $code      compiled code
+     *
+     * @return boolean success
+     */
+    public function write(Smarty_Internal_Template $_template, $code)
+    {
+        if (!$_template->source->handler->recompiled) {
+            if ($_template->smarty->ext->_writeFile->writeFile($this->filepath, $code, $_template->smarty) === true) {
+                $this->timestamp = $this->exists = is_file($this->filepath);
+                if ($this->exists) {
+                    $this->timestamp = filemtime($this->filepath);
+                    return true;
+                }
+            }
+            return false;
+        } else {
+            $this->content = $code;
+        }
+        $this->timestamp = time();
+        $this->exists = true;
+        return true;
+    }
+
+    /**
+     * Read compiled content from handler
+     *
+     * @param Smarty_Internal_Template $_template template object
+     *
+     * @return string content
+     */
+    public function read(Smarty_Internal_Template $_template)
+    {
+        if (!$_template->source->handler->recompiled) {
+            return file_get_contents($this->filepath);
+        }
+        return isset($this->content) ? $this->content : false;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_cacheresource_keyvaluestore.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_cacheresource_keyvaluestore.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_cacheresource_keyvaluestore.php	(revision )
@@ -36,6 +36,7 @@
      * @var array
      */
     protected $contents = array();
+
     /**
      * cache for timestamps
      *
@@ -53,10 +54,8 @@
      */
     public function populate(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template)
     {
-        $cached->filepath = $_template->source->uid
-            . '#' . $this->sanitize($cached->source->resource)
-            . '#' . $this->sanitize($cached->cache_id)
-            . '#' . $this->sanitize($cached->compile_id);
+        $cached->filepath = $_template->source->uid . '#' . $this->sanitize($cached->source->resource) . '#' .
+            $this->sanitize($cached->cache_id) . '#' . $this->sanitize($cached->compile_id);
 
         $this->populateTimestamp($cached);
     }
@@ -83,10 +82,11 @@
      *
      * @param  Smarty_Internal_Template $_template template object
      * @param  Smarty_Template_Cached   $cached    cached object
+     * @param bool                      $update    flag if called because cache update
      *
      * @return boolean                 true or false if the cached content does not exist
      */
-    public function process(Smarty_Internal_Template $_template, Smarty_Template_Cached $cached = null)
+    public function process(Smarty_Internal_Template $_template, Smarty_Template_Cached $cached = null, $update = false)
     {
         if (!$cached) {
             $cached = $_template->cached;
@@ -123,10 +123,32 @@
     {
         $this->addMetaTimestamp($content);
 
-        return $this->write(array($_template->cached->filepath => $content), $_template->properties['cache_lifetime']);
+        return $this->write(array($_template->cached->filepath => $content), $_template->cache_lifetime);
     }
 
     /**
+     * Read cached template from cache
+     *
+     * @param  Smarty_Internal_Template $_template template object
+     *
+     * @return string  content
+     */
+    public function readCachedContent(Smarty_Internal_Template $_template)
+    {
+        $content = $_template->cached->content ? $_template->cached->content : null;
+        $timestamp = null;
+        if ($content === null) {
+            if (!$this->fetch($_template->cached->filepath, $_template->source->name, $_template->cache_id, $_template->compile_id, $content, $timestamp, $_template->source->uid)) {
+                return false;
+            }
+        }
+        if (isset($content)) {
+            return $content;
+        }
+        return false;
+    }
+
+    /**
      * Empty cache
      * {@internal the $exp_time argument is ignored altogether }}
      *
@@ -142,7 +164,14 @@
         if (!$this->purge()) {
             $this->invalidate(null);
         }
-
+        // remove from template cache
+        if (isset($smarty->_cache['template_objects'])) {
+            foreach ($smarty->_cache['template_objects'] as $key => $tpl) {
+                if (isset($tpl->cached)) {
+                    unset($smarty->_cache['template_objects'][$key]);
+                }
+            }
+        }
         return - 1;
     }
 
@@ -163,11 +192,21 @@
      */
     public function clear(Smarty $smarty, $resource_name, $cache_id, $compile_id, $exp_time)
     {
-        $uid = $this->getTemplateUid($smarty, $resource_name, $cache_id, $compile_id);
-        $cid = $uid . '#' . $this->sanitize($resource_name) . '#' . $this->sanitize($cache_id) . '#' . $this->sanitize($compile_id);
+        $uid = $this->getTemplateUid($smarty, $resource_name);
+        $cid = $uid . '#' . $this->sanitize($resource_name) . '#' . $this->sanitize($cache_id) . '#' .
+            $this->sanitize($compile_id);
         $this->delete(array($cid));
         $this->invalidate($cid, $resource_name, $cache_id, $compile_id, $uid);
-
+        // remove from template cache
+        if (isset($resource_name) && isset($smarty->_cache['template_objects'])) {
+            if (isset($smarty->_cache['template_objects'])) {
+                foreach ($smarty->_cache['template_objects'] as $key => $tpl) {
+                    if ($tpl->source->uid == $uid && isset($tpl->cached)) {
+                        unset($smarty->_cache['template_objects'][$key]);
+                    }
+                }
+            }
+        }
         return - 1;
     }
 
@@ -176,35 +215,22 @@
      *
      * @param  Smarty $smarty        Smarty object
      * @param  string $resource_name template name
-     * @param  string $cache_id      cache id
-     * @param  string $compile_id    compile id
      *
      * @return string filepath of cache file
+     * @throws \SmartyException
+     *
      */
-    protected function getTemplateUid(Smarty $smarty, $resource_name, $cache_id, $compile_id)
+    protected function getTemplateUid(Smarty $smarty, $resource_name)
     {
-        $uid = '';
         if (isset($resource_name)) {
-            $tpl = new $smarty->template_class($resource_name, $smarty);
-            if ($tpl->source->exists) {
-                $uid = $tpl->source->uid;
+            $source = Smarty_Template_Source::load(null, $smarty, $resource_name);
+            if ($source->exists) {
+                return $source->uid;
             }
-
-            // remove from template cache
-            if ($smarty->allow_ambiguous_resources) {
-                $_templateId = $tpl->source->unique_resource . $tpl->cache_id . $tpl->compile_id;
-            } else {
-                $_templateId = $smarty->joined_template_dir . '#' . $resource_name . $tpl->cache_id . $tpl->compile_id;
-            }
+        }
-            if (isset($_templateId[150])) {
-                $_templateId = sha1($_templateId);
+        return '';
-            }
+    }
-            unset($smarty->template_objects[$_templateId]);
-        }
 
-        return $uid;
-    }
-
     /**
      * Sanitize CacheID components
      *
@@ -214,12 +240,10 @@
      */
     protected function sanitize($string)
     {
-        // some poeple smoke bad weed
         $string = trim($string, '|');
         if (!$string) {
             return null;
         }
-
         return preg_replace('#[^\w\|]+#S', '_', $string);
     }
 
@@ -275,11 +299,8 @@
      */
     protected function getMetaTimestamp(&$content)
     {
-        $s = unpack("N", substr($content, 0, 4));
-        $m = unpack("N", substr($content, 4, 4));
-        $content = substr($content, 8);
-
-        return $s[1] + ($m[1] / 100000000);
+        extract(unpack('N1s/N1m/a*content', $content));
+        return $s + ($m / 100000000);
     }
 
     /**
@@ -380,7 +401,6 @@
             $t[] = 'IVK#COMPILE' . $_compile;
         }
         $_name .= '#';
-        // some poeple smoke bad weed
         $cid = trim($cache_id, '|');
         if (!$cid) {
             return $t;
